// ---------------------------------------------------------------------------
/*
 * (c) Copyright 2010, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * www.allanpetersen.com
 *
 */
// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// ---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{
	int exStyle;

	// Enable window layering
	exStyle = GetWindowLongA(Handle, GWL_EXSTYLE);
	if ((exStyle & WS_EX_LAYERED) == 0)
		SetWindowLong(Handle, GWL_EXSTYLE, exStyle | WS_EX_LAYERED);

	Alpha = 0;
	UpDown = true;

	// Position bitmap on form
	BitmapPos = Point(0, 0);

	// Setup alpha blending parameters
	BlendFunction.BlendOp = AC_SRC_OVER;
	BlendFunction.BlendFlags = 0;
	BlendFunction.SourceConstantAlpha = Alpha;
	BlendFunction.AlphaFormat = AC_SRC_ALPHA;
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::OnPaint(Graphics::TBitmap *Sender)
{
	AnsiString Text;

	// ---- Setting Bitmap Size
	BitmapSize.cx = Sender->Width;
	BitmapSize.cy = Sender->Height;

	// Setup alpha blending parameters
	BlendFunction.SourceConstantAlpha = Alpha;

	// ---- Update layer
	UpdateLayeredWindow(Handle, 0, NULL, &BitmapSize, Sender->Canvas->Handle,  &BitmapPos, 0, &BlendFunction, ULW_ALPHA);

	// ---- change translucency
	Alpha += UpDown ? 1 : -1;
	if (Alpha > 255 || Alpha < 0) {
		UpDown = !UpDown;
		Alpha += UpDown ? 1 : -1;
	}
	// ---- Display the frame rate as hint
	Hint = Text.sprintf("FPS: %.2f", Form2->Fps);
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
	Form2->OnPaint = OnPaint;

}
// ---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
	Form2->Width = Width;
	Form2->Height = Height;

}
// ---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
	// ---- Release any mouse cature functionallity
	ReleaseCapture();
	// ---- "Fool" the mouse to hit the caption and
	// ---- initiate a move command to the system
	SNDMSG(Handle, WM_SYSCOMMAND, SC_MOVE + HTCAPTION, 0);
}
// ---------------------------------------------------------------------------
void __fastcall TForm1::Close1Click(TObject *Sender)
{
	Close();
}
// ---------------------------------------------------------------------------
